error_gB11=reshape(error_gB(1,1,26,:),[],1);      %(-3,0,5)
error_gB22=reshape(error_gB(2,2,26,:),[],1);
error_gB13=reshape(error_gB(1,3,26,:),[],1);
error_gB33=reshape(error_gB(3,3,26,:),[],1);
error_GB111=reshape(error_GB(1,1,1,26,:),[],1);
error_GB131=reshape(error_GB(1,3,1,26,:),[],1);
error_GB221=reshape(error_GB(2,2,1,26,:),[],1);
error_GB331=reshape(error_GB(3,3,1,26,:),[],1);
error_GB122=reshape(error_GB(1,2,2,26,:),[],1);
error_GB232=reshape(error_GB(2,3,2,26,:),[],1);
error_GB113=reshape(error_GB(1,1,3,26,:),[],1);
error_GB133=reshape(error_GB(1,3,3,26,:),[],1);
error_GB223=reshape(error_GB(2,2,3,26,:),[],1);
error_GB333=reshape(error_GB(3,3,3,26,:),[],1);
figure('Color','w','units','pixels','position',[50,50,800,800],'paperunits','centimeters','papersize',[21,29.7])
panel_width=0.35;
panel_height=0.4;
panel_gap=0.06;
left=0.08;
bottom=0.08;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Define a CVD-friendly color order with ten distinct colors
cvdColorOrder = [
    230/255, 159/255, 0;  % Orange
    86/255, 180/255, 233/255; % Sky Blue
    0, 158/255, 115/255; % Bluish Green
    213/255, 94/255, 0; % Vermillion
    0, 114/255, 178/255; % Blue
    204/255, 121/255, 167/255; % Reddish Purple
    153/255, 153/255, 153/255; % Gray
    117/255, 112/255, 179/255; % Purplish Blue
    240/255, 228/255, 66/255; % Yellow
    0, 0, 0;         % Black
];
colororder(cvdColorOrder)     % Set the color order for the current figure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot('position',[left,bottom+(panel_height+panel_gap),panel_width,panel_height]);
error_gB_plot=[error_gB11,error_gB22,error_gB13,error_gB33];
plot(1:iteration_n,error_gB_plot,'LineWidth',1)
legend('\partialBx/\partialx','\partialBy/\partialy','\partialBz/\partialx','\partialBz/\partialz')
xlabel('Iteration (count)')
ylabel('Errors (%)')
% axis([0,200,0,0.2])
text(0.05,0.9,'barycenter at (-3, 0, 5)','Units','normalized')
text(0.01,0.975,'(a)','Units','normalized')

subplot('position',[left+(panel_width+panel_gap),bottom+(panel_height+panel_gap),panel_width,panel_height]);
error_GB_plot=[error_GB111,error_GB131,error_GB221,error_GB331,error_GB122,error_GB232,error_GB113,error_GB133,error_GB223,error_GB333];
plot(1:iteration_n,error_GB_plot,'LineWidth',1)
legend('\partial^2Bx/\partialx^2','\partial^2Bx/\partialx\partialz','\partial^2Bx/\partialy^2',...
       '\partial^2Bx/\partialz^2','\partial^2By/\partialx\partialy','\partial^2By/\partialy\partialz',...
       '\partial^2Bz/\partialx^2','\partial^2Bz/\partialx\partialz','\partial^2Bz/\partialy^2','\partial^2Bz/\partialz^2',...
       'location','none','position',[0.85,0.69,0.132,0.25])
xlabel('Iteration (count)')
ylabel('Errors (%)')
% axis([0,200,0,7])
text(0.05,0.9,'barycenter at (-3, 0, 5)','Units','normalized')
text(0.01,0.975,'(b)','Units','normalized')

error_gB11=reshape(error_gB(1,1,106,:),[],1);      %(3.4,0,5)
error_gB22=reshape(error_gB(2,2,106,:),[],1);
error_gB13=reshape(error_gB(1,3,106,:),[],1);
error_gB33=reshape(error_gB(3,3,106,:),[],1);
error_GB111=reshape(error_GB(1,1,1,106,:),[],1);
error_GB131=reshape(error_GB(1,3,1,106,:),[],1);
error_GB221=reshape(error_GB(2,2,1,106,:),[],1);
error_GB331=reshape(error_GB(3,3,1,106,:),[],1);
error_GB122=reshape(error_GB(1,2,2,106,:),[],1);
error_GB232=reshape(error_GB(2,3,2,106,:),[],1);
error_GB113=reshape(error_GB(1,1,3,106,:),[],1);
error_GB133=reshape(error_GB(1,3,3,106,:),[],1);
error_GB223=reshape(error_GB(2,2,3,106,:),[],1);
error_GB333=reshape(error_GB(3,3,3,106,:),[],1);

subplot('position',[left,bottom,panel_width,panel_height]);
plot(1:iteration_n,error_gB11,'LineWidth',1)
hold on
plot(1:iteration_n,error_gB22,'LineWidth',1)
plot(1:iteration_n,error_gB13,'LineWidth',1)
plot(1:iteration_n,error_gB33,'LineWidth',1)
legend('\partialBx/\partialx','\partialBy/\partialy','\partialBz/\partialx','\partialBz/\partialz')
xlabel('Iteration (count)')
ylabel('Errors (%)')
% axis([0,200,0,0.2])
text(0.05,0.9,'barycenter at (3.4,0,5)','Units','normalized')
text(0.01,0.975,'(c)','Units','normalized')

subplot('position',[left+(panel_width+panel_gap),bottom,panel_width,panel_height]);
plot(1:iteration_n,error_GB111,'LineWidth',1)
hold on
plot(1:iteration_n,error_GB131,'LineWidth',1)
plot(1:iteration_n,error_GB221,'LineWidth',1)
plot(1:iteration_n,error_GB331,'LineWidth',1)
plot(1:iteration_n,error_GB122,'LineWidth',1)
plot(1:iteration_n,error_GB232,'LineWidth',1)
plot(1:iteration_n,error_GB113,'LineWidth',1)
plot(1:iteration_n,error_GB133,'LineWidth',1)
plot(1:iteration_n,error_GB223,'LineWidth',1)
plot(1:iteration_n,error_GB333,'LineWidth',1)
legend('\partial^2Bx/\partialx^2','\partial^2Bx/\partialx\partialz','\partial^2Bx/\partialy^2',...
       '\partial^2Bx/\partialz^2','\partial^2By/\partialx\partialy','\partial^2By/\partialy\partialz',...
       '\partial^2Bz/\partialx^2','\partial^2Bz/\partialx\partialz','\partial^2Bz/\partialy^2','\partial^2Bz/\partialz^2',...
       'location','none','position',[0.85,0.23,0.132,0.25])
xlabel('Iteration (count)')
ylabel('Errors (%)')
% axis([0,200,0,3.5])
text(0.05,0.9,'barycenter at (3.4, 0, 5)','Units','normalized')
text(0.01,0.975,'(d)','Units','normalized')
% print('Dipole_error_200','-dpdf','-bestfit')
% close

error_gB11=reshape(error_gB(1,1,:,end),[],1);  
error_gB22=reshape(error_gB(2,2,:,end),[],1);
error_gB13=reshape(error_gB(1,3,:,end),[],1);
error_gB33=reshape(error_gB(3,3,:,end),[],1);
error_GB111=reshape(error_GB(1,1,1,:,end),[],1);
error_GB131=reshape(error_GB(1,3,1,:,end),[],1);
error_GB221=reshape(error_GB(2,2,1,:,end),[],1);
error_GB331=reshape(error_GB(3,3,1,:,end),[],1);
error_GB122=reshape(error_GB(1,2,2,:,end),[],1);
error_GB232=reshape(error_GB(2,3,2,:,end),[],1);
error_GB113=reshape(error_GB(1,1,3,:,end),[],1);
error_GB133=reshape(error_GB(1,3,3,:,end),[],1);
error_GB223=reshape(error_GB(2,2,3,:,end),[],1);
error_GB333=reshape(error_GB(3,3,3,:,end),[],1);
figure('Color','w','units','pixels','position',[50,50,900,500],'paperunits','centimeters','papersize',[21,29.7])
panel_width=0.36;
panel_height=0.8;
panel_gap=0.1;
left=0.1;
bottom=0.1;
colororder(cvdColorOrder)     % Set the color order for the current figure
subplot('position',[left,bottom,panel_width,panel_height]);
plot(tc,error_gB11,'LineWidth',1)
hold on
plot(tc,error_gB22,'LineWidth',1)
plot(tc,error_gB13,'LineWidth',1)
plot(tc,error_gB33,'LineWidth',1)

xlim([0 130])
legend('\partialBx/\partialx','\partialBy/\partialy','\partialBz/\partialx','\partialBz/\partialz')
xlabel('Time (s)')
ylabel('Errors (%)')
text(-11,-0.02,'barycenter','HorizontalAlignment','right')
text(0,-0.02,'(-5,0,5)','HorizontalAlignment','center')
text(126,-0.02,'(5,0,5)','HorizontalAlignment','center')
text(1.3,0.24375,'(a)')

subplot('position',[left+(panel_width+panel_gap),bottom,panel_width,panel_height]);
plot(tc,error_GB111,'LineWidth',1)
hold on
plot(tc,error_GB131,'LineWidth',1)
plot(tc,error_GB221,'LineWidth',1)
plot(tc,error_GB331,'LineWidth',1)
plot(tc,error_GB122,'LineWidth',1)
plot(tc,error_GB232,'LineWidth',1)
plot(tc,error_GB113,'LineWidth',1)
plot(tc,error_GB133,'LineWidth',1)
plot(tc,error_GB223,'LineWidth',1)
plot(tc,error_GB333,'LineWidth',1)
xlim([0 130])
legend('\partial^2Bx/\partialx^2','\partial^2Bx/\partialx\partialz','\partial^2Bx/\partialy^2',...
       '\partial^2Bx/\partialz^2','\partial^2By/\partialx\partialy','\partial^2By/\partialy\partialz',...
       '\partial^2Bz/\partialx^2','\partial^2Bz/\partialx\partialz','\partial^2Bz/\partialy^2','\partial^2Bz/\partialz^2',...
       'Position',[0.58,0.4209,0.1180,0.4010])
xlabel('Time (s)')
ylabel('Errors (%)')
text(0,-4,'(-5,0,5)','HorizontalAlignment','center')
text(126,-4,'(5,0,5)','HorizontalAlignment','center')
text(1.3,48.75,'(b)')
% print('Dipole_error_t','-dpdf','-bestfit')
% close

figure('Color','w','units','pixels','position',[50,50,1000,900],'paperunits','centimeters','papersize',[21,29.7])
panel_width=0.35;
panel_height=0.4;
panel_gap=0.02;
left=0.1;
bottom=0.08;
subplot('position',[left,bottom+(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(dB(1,1,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(gB(1,1,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partialBx/\partialx','(nT\cdotR_E^{-2})'})
legend({'Accurate','Algorithm'},'Location','north');
text(1.3,45,'(a)')

subplot('position',[left+(panel_width+6*panel_gap),bottom+(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(dB(2,2,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(gB(2,2,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partialBy/\partialy','(nT\cdotR_E^{-2})'})
text(1.3,-23.5,'(b)')

subplot('position',[left,bottom,panel_width,panel_height]);
plot(tc,reshape(dB(3,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(gB(3,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130])
xlabel('Time (s)')
ylabel({'\partialBz/\partialz','(nT\cdotR_E^{-2})'})
text(1.3,291.25,'(c)')

subplot('position',[left+(panel_width+6*panel_gap),bottom,panel_width,panel_height]);
plot(tc,reshape(dB(1,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(gB(1,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130])
xlabel('Time (s)')
ylabel({'\partialBz/\partialx','(nT\cdotR_E^{-2})'})
text(1.3,142.5,'(d)')
% print('Dipole_gB','-dpdf','-bestfit')
% close

figure('Color','w','units','pixels','position',[50,50,800,1000],'paperunits','centimeters','papersize',[21,29.7])
panel_width=0.35;
panel_height=0.15;
panel_gap=0.02;
left=0.1;
bottom=0.08;
subplot('position',[left,bottom+4*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(1,1,1,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(1,1,1,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partial^2Bx/\partialx^2','(nT\cdotR_E^{-2})'})
legend({'Accurate','Algorithm'},'Position',[0.1426,0.8727,0.1218,0.0317]);
text(1.3,90,'(a)')

subplot('position',[left+(panel_width+6*panel_gap),bottom+4*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(1,3,1,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(1,3,1,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partial^2Bx/\partialx\partialz','(nT\cdotR_E^{-2})'})
text(1.3,140,'(b)')

subplot('position',[left,bottom+3*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(2,2,1,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(2,2,1,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partial^2Bx/\partialy^2','(nT\cdotR_E^{-2})'})
text(1.3,36,'(c)')

subplot('position',[left+(panel_width+6*panel_gap),bottom+3*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(3,3,1,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(3,3,1,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'YLim',[-120,120],'XTickLabel',{' '},'YTick',-120:40:120)
ylabel({'\partial^2Bx/\partialz^2','(nT\cdotR_E^{-2})'})
text(1.3,108,'(d)')

subplot('position',[left,bottom+2*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(1,2,2,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(1,2,2,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partial^2By/\partialx\partialy','(nT\cdotR_E^{-2})'})
text(1.3,36,'(e)')

subplot('position',[left+(panel_width+6*panel_gap),bottom+2*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(2,3,2,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(2,3,2,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'YLim',[0,120],'XTickLabel',{' '},'YTick',0:30:120)
ylabel({'\partial^2By/\partialy\partialz','(nT\cdotR_E^{-2})'})
text(1.3,114,'(f)')

subplot('position',[left,bottom+1*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(1,1,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(1,1,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'XTickLabel',{' '})
ylabel({'\partial^2Bz/\partialx^2','(nT\cdotR_E^{-2})'})
text(1.3,140,'(g)')

subplot('position',[left+(panel_width+6*panel_gap),bottom+1*(panel_height+panel_gap),panel_width,panel_height]);
plot(tc,reshape(ddB(1,3,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(1,3,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'YLim',[-120,120],'XTickLabel',{' '},'YTick',-120:40:120)
ylabel({'\partial^2Bz/\partialx\partialz','(nT\cdotR_E^{-2})'})
text(1.3,108,'(h)')

subplot('position',[left,bottom,panel_width,panel_height]);
plot(tc,reshape(ddB(2,2,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(2,2,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'YLim',[0,120],'YTick',0:30:120)
xlabel('Time (s)')
ylabel({'\partial^2Bz/\partialy^2','(nT\cdotR_E^{-2})'})
text(1.3,114,'(i)')

subplot('position',[left+(panel_width+6*panel_gap),bottom,panel_width,panel_height]);
plot(tc,reshape(ddB(3,3,3,:,end),[],1),'k','LineWidth',1)
hold on;
plot(tc,reshape(GB(3,3,3,:,end),[],1),'o','color','[0 0.4470 0.7410]','MarkerSize',4)
set(gca,'XLim',[0,130],'YLim',[-250,50],'YTick',-250:50:50)
xlabel('Time (s)')
ylabel({'\partial^2Bz/\partialz^2','(nT\cdotR_E^{-2})'})
text(1.3,35,'(j)')
% print('Dipole_GGB','-dpdf','-bestfit')
% close